package br.ufrn.imd.balance.service;

import br.ufrn.imd.balance.domain.Account;
import br.ufrn.imd.balance.domain.Client;
import br.ufrn.imd.balance.exception.BadRequestException;
import br.ufrn.imd.balance.repository.ClientRepository;
import lombok.AllArgsConstructor;
import lombok.RequiredArgsConstructor;
import lombok.extern.java.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Log
@Service
@RequiredArgsConstructor
public class BalanceService {
    private final ClientRepository clientRepository;

    public Client balance(Client client) {
        Client persistedClient = clientRepository.findById(client.getId())
                .orElseThrow(() -> new BadRequestException("Invalid user!"));
        Account account = client.getAccount();
        log.info(String.format("Account Balance: R$ %.2f", account.getBalance()));

        return persistedClient;
    }
}
