package br.ufrn.imd.deposit.service;

import br.ufrn.imd.deposit.domain.Account;
import br.ufrn.imd.deposit.domain.Client;
import br.ufrn.imd.deposit.repository.ClientRepository;
import lombok.AllArgsConstructor;
import lombok.extern.java.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Log
@AllArgsConstructor
@Service
public class DepositService {
    @Autowired
    private final ClientRepository clientRepository;

    public Client deposit(Double value, Client client) {
        client = clientRepository.findById(client.getId())
                .orElseThrow(() -> new RuntimeException("Invalid user!"));

        Account account = client.getAccount();
        account.setBalance(account.getBalance() + value);
        client = clientRepository.save(client);

        log.info("Deposit concluded!");
        log.info(String.format("Total: %.2f", client.getAccount().getBalance()));

        return client;
    }
}
