package br.ufrn.imd.transfer.controller;

import br.ufrn.imd.transfer.domain.Account;
import br.ufrn.imd.transfer.domain.Client;
import br.ufrn.imd.transfer.service.TransferService;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

@AllArgsConstructor
@RestController
@RequestMapping("/banking/client/{id}")
public class TransferController {
    @Autowired
    private final TransferService service;

    @GetMapping
    @ResponseStatus(HttpStatus.OK)
    public Client transfer(@PathVariable Integer id, @RequestParam(name = "value") Double value,
                           @RequestParam(name = "toAccount") String toAccountNumber) {
        return service.transfer(value, new Client(id), new Account(null, toAccountNumber, null, null));
    }
}
